> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Manage earn position

> Deposit into or withdraw from a yield venue.

Use `DEPOSIT` to move tokens from the Earn Account into a vault, Aave market, or Pendle PT position. Use `WITHDRAW` to move tokens back from a venue into the Earn Account.

**Venue types:**
- `VAULT`: ERC-4626 vaults (see [/vaults](https://docs.compasslabs.ai/v2/api-reference/earn/list-vaults) for available options)
- `AAVE`: Aave lending pools (see [/aave_markets](https://docs.compasslabs.ai/v2/api-reference/earn/list-aave-markets) for available options)
- `PENDLE_PT`: Pendle Principal Tokens (see [/pendle_markets](https://docs.compasslabs.ai/v2/api-reference/earn/list-pendle-markets) for available options)

**Fees:** A fee can be configured and deducted from the transaction amount (not supported for PENDLE_PT):
- `FIXED`: A fixed token amount (e.g., 0.1 means 0.1 tokens)
- `PERCENTAGE`: A percentage of the amount (e.g., 1.5 means 1.5%)
- `PERFORMANCE`: A percentage of realized profit (withdrawals only)

**Gas sponsorship:** Set `gas_sponsorship=true` to receive EIP-712 typed data. Owner signs the typed data, then submit to [/gas_sponsorship/prepare](https://docs.compasslabs.ai/v2/api-reference/gas-sponsorship/prepare-gas-sponsored-transaction).



## OpenAPI

````yaml /v2/combined_spec.json post /v2/earn/manage
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v2/earn/manage:
    post:
      tags:
        - Earn
      summary: Manage earn position
      description: >-
        Deposit into or withdraw from a yield venue.


        Use `DEPOSIT` to move tokens from the Earn Account into a vault, Aave
        market, or Pendle PT position. Use `WITHDRAW` to move tokens back from a
        venue into the Earn Account.


        **Venue types:**

        - `VAULT`: ERC-4626 vaults (see
        [/vaults](https://docs.compasslabs.ai/v2/api-reference/earn/list-vaults)
        for available options)

        - `AAVE`: Aave lending pools (see
        [/aave_markets](https://docs.compasslabs.ai/v2/api-reference/earn/list-aave-markets)
        for available options)

        - `PENDLE_PT`: Pendle Principal Tokens (see
        [/pendle_markets](https://docs.compasslabs.ai/v2/api-reference/earn/list-pendle-markets)
        for available options)


        **Fees:** A fee can be configured and deducted from the transaction
        amount (not supported for PENDLE_PT):

        - `FIXED`: A fixed token amount (e.g., 0.1 means 0.1 tokens)

        - `PERCENTAGE`: A percentage of the amount (e.g., 1.5 means 1.5%)

        - `PERFORMANCE`: A percentage of realized profit (withdrawals only)


        **Gas sponsorship:** Set `gas_sponsorship=true` to receive EIP-712 typed
        data. Owner signs the typed data, then submit to
        [/gas_sponsorship/prepare](https://docs.compasslabs.ai/v2/api-reference/gas-sponsorship/prepare-gas-sponsored-transaction).
      operationId: v2_earn_manage
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/EarnManageRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EarnManageResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.earn.earn_manage(venue={
                    "type": "VAULT",
                    "vault_address": "0x7BfA7C4f149E7415b73bdeDfe609237e29CBF34A",
                }, action=models.EarnManageRequestAction.DEPOSIT, amount="0.01", owner="0x06A9aF046187895AcFc7258450B15397CAc67400", chain=models.Chain.BASE, fee={
                    "recipient": "<value>",
                    "amount": "263.30",
                    "denomination": models.FeeDenomination.PERCENTAGE,
                }, gas_sponsorship=False)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.earn.earnManage({
                venue: {
                  type: "VAULT",
                  vaultAddress: "0x7BfA7C4f149E7415b73bdeDfe609237e29CBF34A",
                },
                action: "DEPOSIT",
                amount: "0.01",
                owner: "0x06A9aF046187895AcFc7258450B15397CAc67400",
                chain: "base",
                gasSponsorship: false,
              });

              console.log(result);
            }

            run();
components:
  schemas:
    EarnManageRequest:
      properties:
        action_type:
          type: string
          const: V2_MANAGE
          title: Action Type
          description: Action type identifier for manage operations.
          default: V2_MANAGE
        venue:
          oneOf:
            - $ref: '#/components/schemas/VaultVenue'
            - $ref: '#/components/schemas/AaveVenue'
            - $ref: '#/components/schemas/PendlePTVenue'
          title: Venue
          description: The earn venue.
          discriminator:
            propertyName: type
            mapping:
              AAVE:
                $ref: '#/components/schemas/AaveVenue'
              PENDLE_PT:
                $ref: '#/components/schemas/PendlePTVenue'
              VAULT:
                $ref: '#/components/schemas/VaultVenue'
          default:
            type: VAULT
            vault_address: '0x7BfA7C4f149E7415b73bdeDfe609237e29CBF34A'
          examples:
            - type: VAULT
              vault_address: '0x7BfA7C4f149E7415b73bdeDfe609237e29CBF34A'
        action:
          type: string
          enum:
            - DEPOSIT
            - WITHDRAW
          title: Action
          description: >-
            Whether you are depositing into or withdrawing from the given Earn
            `venue`.
          default: DEPOSIT
          examples:
            - DEPOSIT
        amount:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount
          description: >-
            Amount of the underlying asset to act on (deposit or withdraw). For
            VAULT, this is the vault's underlying token; for AAVE, this is the
            Aave reserve asset; for PENDLE_PT, this is the amount of `token` to
            spend (DEPOSIT) or PT to sell (WITHDRAW). Provide as a decimal in
            token units (not wei); must be > 0.
          examples:
            - 0.1
            - 1
            - 100.001
          default: '0.01'
        fee:
          anyOf:
            - $ref: '#/components/schemas/Fee'
            - type: 'null'
          description: >-
            Optional fee configuration. If provided, a fee will be applied to
            the transaction amount and sent to the specified recipient address.
            The fee can be specified as a percentage of the transaction amount,
            as a fixed token amount, or as a percentage of realized profit
            (PERFORMANCE).
        owner:
          type: string
          title: Owner
          description: The primary wallet address that owns and controls the Earn Account.
          default: '0x06A9aF046187895AcFc7258450B15397CAc67400'
          examples:
            - '0x06A9aF046187895AcFc7258450B15397CAc67400'
        chain:
          $ref: '#/components/schemas/Chain'
          description: Blockchain network
          default: base
          examples:
            - base
        gas_sponsorship:
          type: boolean
          title: Gas Sponsorship
          description: >-
            Optionally request gas sponsorship. If set to `true`, EIP-712 typed
            data will be returned that must be signed by the `owner` and
            submitted to the 'Prepare gas-sponsored transaction' endpoint
            (`/gas_sponsorship/prepare`).
          default: false
          examples:
            - false
      type: object
      required:
        - venue
        - action
        - amount
        - owner
        - chain
      title: EarnManageRequest
      description: >-
        Request model for the unified manage endpoint.


        Inherits from EarnManageParams and adds context fields (owner, chain,
        etc).
      default:
        owner: '0x06A9aF046187895AcFc7258450B15397CAc67400'
        chain: base
        venue:
          type: VAULT
          vault_address: '0x7BfA7C4f149E7415b73bdeDfe609237e29CBF34A'
        action: DEPOSIT
        amount: '0.01'
        gas_sponsorship: false
    EarnManageResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - type: 'null'
          description: >-
            Unsigned transaction for direct execution. Present when
            gas_sponsorship=false.
        eip_712:
          anyOf:
            - $ref: '#/components/schemas/BatchedSafeOperationsResponse-Output'
            - type: 'null'
          description: >-
            EIP-712 typed data for gas-sponsored execution. Present when
            gas_sponsorship=true.
      type: object
      title: EarnManageResponse
      example:
        transaction:
          chainId: '0x2105'
          data: >-
            0x8d80ff0a0000000000000000000000000000000000000000000000000000000000000020
          from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
          gas: '0x7a120'
          maxFeePerGas: '0x59682f00'
          maxPriorityFeePerGas: '0x3b9aca00'
          nonce: '0x5'
          to: '0x6B90E8B4E3E971E74C1A47a3a20976377E2dB4b1'
          value: '0x0'
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    VaultVenue:
      properties:
        type:
          type: string
          const: VAULT
          title: Type
          description: The venue type discriminator.
          examples:
            - VAULT
            - AAVE
            - PENDLE_PT
        vault_address:
          type: string
          title: Vault Address
          description: The vault address you are interacting with for this action.
          examples:
            - '0xBEEF01735c132Ada46AA9aA4c54623cAA92A64CB'
      additionalProperties: false
      type: object
      required:
        - type
        - vault_address
      title: VaultVenue
    AaveVenue:
      properties:
        type:
          type: string
          const: AAVE
          title: Type
          description: The venue type discriminator.
          examples:
            - VAULT
            - AAVE
            - PENDLE_PT
        token:
          type: string
          title: Token
          description: The reserve token for the Aave pool you are interacting with.
          examples:
            - USDC
            - '0xa0b86991c6218b36c1d19d4a2e9eb0ce3606eb48'
      additionalProperties: false
      type: object
      required:
        - type
        - token
      title: AaveVenue
    PendlePTVenue:
      properties:
        type:
          type: string
          const: PENDLE_PT
          title: Type
          description: The venue type discriminator.
          examples:
            - VAULT
            - AAVE
            - PENDLE_PT
        market_address:
          type: string
          title: Market Address
          description: The Pendle market address identifying which PT to trade.
          examples:
            - '0x08a152834de126d2ef83d612ff36e4523fd0017f'
        token:
          anyOf:
            - type: string
              title: Token
              description: >-
                A token identifier - either a supported symbol (e.g., USDC,
                WETH) or a valid Ethereum address (0x...)
              examples:
                - USDC
                - WETH
                - '0xA0b86a33E6441ccF30EE5DdEF1E9b652C91ac1c8'
            - type: 'null'
          title: Token
          description: >-
            The token to exchange for PT (only used for DEPOSIT/buy). For
            WITHDRAW/sell, this field must not be provided - withdrawals always
            return the underlying asset to ensure accurate yield fee
            calculation.
          examples:
            - USDC
            - '0xaf88d065e77c8cC2239327C5EDb3A432268e5831'
        max_slippage_percent:
          type: number
          maximum: 10
          minimum: 0
          title: Max Slippage Percent
          description: Maximum slippage allowed in percent (e.g., 1 means 1% slippage).
          default: 1
          examples:
            - 0.5
            - 1
            - 2
      additionalProperties: false
      type: object
      required:
        - type
        - market_address
      title: PendlePTVenue
      description: Venue for Pendle Principal Token (PT) positions.
    Fee:
      properties:
        recipient:
          type: string
          title: Recipient
          description: The wallet address that will receive the fee.
          examples:
            - '0xb8340945eBc917D2Aa0368a5e4E79C849c461511'
        amount:
          anyOf:
            - type: number
              exclusiveMinimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount
          description: >-
            The fee amount. If `denomination` is 'PERCENTAGE', this is a
            percentage of the transaction amount (e.g., 1.5 for 1.5%). If
            `denomination` is 'FIXED', this is a fixed amount in token units
            (e.g., 0.1 for 0.1 tokens). If `denomination` is 'PERFORMANCE', this
            is a percentage of realized profit calculated using FIFO cost basis
            (e.g., 10 for 10% of profit).
          examples:
            - 1.5
            - 0.1
            - 10
        denomination:
          type: string
          enum:
            - PERCENTAGE
            - FIXED
            - PERFORMANCE
          title: Denomination
          description: >-
            The unit type for the fee amount. Use 'PERCENTAGE' for a
            percentage-based fee (e.g., 1.5 means 1.5% of the transaction
            amount), 'FIXED' for a fixed token amount (e.g., 0.1 means 0.1
            tokens), or 'PERFORMANCE' for a fee based on realized profit using
            FIFO cost basis (e.g., 10 means 10% of profit).
          default: PERCENTAGE
          examples:
            - PERCENTAGE
            - FIXED
            - PERFORMANCE
      additionalProperties: false
      type: object
      required:
        - recipient
        - amount
      title: Fee
    Chain:
      type: string
      enum:
        - base
        - ethereum
        - arbitrum
        - hyperevm
        - tempo
      title: Chain
      description: The chain to use.
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    BatchedSafeOperationsResponse-Output:
      properties:
        domain:
          $ref: >-
            #/components/schemas/compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Domain
          description: EIP-712 domain separator
        types:
          $ref: >-
            #/components/schemas/compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Types
          description: EIP-712 type definitions
        primaryType:
          type: string
          const: SafeTx
          title: Primarytype
          description: Primary type for the structured data
        message:
          $ref: '#/components/schemas/SafeTxMessage'
          description: Safe transaction message data
      type: object
      required:
        - domain
        - types
        - primaryType
        - message
      title: BatchedSafeOperationsResponse
      description: Response containing EIP-712 typed data for Safe transaction signing.
      example:
        domain:
          chainId: 8453
          verifyingContract: '0x6B90E8B4E3E971E74C1A47a3a20976377E2dB4b1'
        message:
          baseGas: '0'
          data: >-
            0x8d80ff0a0000000000000000000000000000000000000000000000000000000000000020
          gasPrice: '0'
          gasToken: '0x0000000000000000000000000000000000000000'
          nonce: '7'
          operation: 1
          refundReceiver: '0x0000000000000000000000000000000000000000'
          safeTxGas: '0'
          to: '0x93C23AAE4793C14D6DF35D2A2A2234204e1559dA'
          value: '0'
        primaryType: SafeTx
        types:
          EIP712Domain:
            - name: chainId
              type: uint256
            - name: verifyingContract
              type: address
          SafeTx:
            - name: to
              type: address
            - name: value
              type: uint256
            - name: data
              type: bytes
            - name: operation
              type: uint8
            - name: safeTxGas
              type: uint256
            - name: baseGas
              type: uint256
            - name: gasPrice
              type: uint256
            - name: gasToken
              type: address
            - name: refundReceiver
              type: address
            - name: nonce
              type: uint256
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Domain:
      properties:
        chainId:
          type: integer
          title: Chainid
          description: Chain ID
        verifyingContract:
          type: string
          title: Verifyingcontract
          description: Address of the Product Account
      type: object
      required:
        - chainId
        - verifyingContract
      title: EIP712Domain
      description: The EIP-712 domain separator.
    compass__api_backend__v2__models__safe__transact__response__batched_safe_operations__EIP712Types:
      properties:
        EIP712Domain:
          items:
            $ref: '#/components/schemas/EIP712DomainField'
          type: array
          title: Eip712Domain
          description: EIP712Domain type definition
        SafeTx:
          items:
            $ref: '#/components/schemas/SafeTxField'
          type: array
          title: Safetx
          description: SafeTx type definition
      type: object
      required:
        - EIP712Domain
        - SafeTx
      title: EIP712Types
      description: The type definitions for EIP-712 structured data.
    SafeTxMessage:
      properties:
        to:
          type: string
          title: To
          description: Destination address
        value:
          type: string
          title: Value
          description: Value in wei as a string
        data:
          type: string
          title: Data
          description: Transaction data as hex string
        operation:
          $ref: '#/components/schemas/OperationType'
          description: Operation type (0=Call, 1=DelegateCall)
        safeTxGas:
          type: string
          title: Safetxgas
          description: Gas for the transaction
        baseGas:
          type: string
          title: Basegas
          description: Base gas costs
        gasPrice:
          type: string
          title: Gasprice
          description: Gas price
        gasToken:
          type: string
          title: Gastoken
          description: Token address for gas payment
        refundReceiver:
          type: string
          title: Refundreceiver
          description: Address to receive gas refund
        nonce:
          type: string
          title: Nonce
          description: Transaction nonce
      type: object
      required:
        - to
        - value
        - data
        - operation
        - safeTxGas
        - baseGas
        - gasPrice
        - gasToken
        - refundReceiver
        - nonce
      title: SafeTxMessage
      description: The message data for the transaction.
    EIP712DomainField:
      properties:
        name:
          type: string
          title: Name
        type:
          type: string
          title: Type
      type: object
      required:
        - name
        - type
      title: EIP712DomainField
      description: A field in the EIP712Domain type definition.
    SafeTxField:
      properties:
        name:
          type: string
          title: Name
        type:
          type: string
          title: Type
      type: object
      required:
        - name
        - type
      title: SafeTxField
      description: A field in the SafeTx type definition.
    OperationType:
      type: integer
      enum:
        - 0
        - 1
      title: OperationType
      description: Safe operation types.
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````